Open CASCADE Technology
7.1.0.beta
|
MakeRevolutionForm Generates a surface of revolution in the feature as it slides along a revolved face in the basis shape. The semantics of mechanical features is built around giving thickness to a contour. This thickness can either be unilateral - on one side of the contour - or bilateral - on both sides. As in the semantics of form features, the thickness is defined by construction of shapes in specific contexts. The development contexts differ, however,in case of mechanical features. Here they include extrusion: More...
#include <BRepFeat_MakeRevolutionForm.hxx>
Public Member Functions | |
BRepFeat_MakeRevolutionForm () | |
initializes the linear form class. More... | |
BRepFeat_MakeRevolutionForm (const TopoDS_Shape &Sbase, const TopoDS_Wire &W, const Handle< Geom_Plane > &Plane, const gp_Ax1 &Axis, const Standard_Real Height1, const Standard_Real Height2, const Standard_Integer Fuse, Standard_Boolean &Sliding) | |
a contour W, a shape Sbase and a plane P are initialized to serve as the basic elements in the construction of the rib or groove. The axis Axis of the revolved surface in the basis shape defines the feature's axis of revolution. Height1 and Height2 may be used as limits to the construction of the feature. Fuse offers a choice between: More... | |
void | Init (const TopoDS_Shape &Sbase, const TopoDS_Wire &W, const Handle< Geom_Plane > &Plane, const gp_Ax1 &Axis, const Standard_Real Height1, const Standard_Real Height2, const Standard_Integer Fuse, Standard_Boolean &Sliding) |
Initializes this construction algorithm A contour W, a shape Sbase and a plane P are initialized to serve as the basic elements in the construction of the rib or groove. The axis Axis of the revolved surface in the basis shape defines the feature's axis of revolution. Height1 and Height2 may be used as limits to the construction of the feature. Fuse offers a choice between: More... | |
void | Add (const TopoDS_Edge &E, const TopoDS_Face &OnFace) |
Indicates that the edge <E> will slide on the face <OnFace>. Raises ConstructionError if the face does not belong to the basis shape, or the edge to the prismed shape. More... | |
void | Perform () |
Performs a prism from the wire to the plane along the basis shape S. Reconstructs the feature topologically. More... | |
Standard_Boolean | Propagate (TopTools_ListOfShape &L, const TopoDS_Face &F, const gp_Pnt &FPoint, const gp_Pnt &LPoint, Standard_Boolean &falseside) |
Public Member Functions inherited from BRepFeat_RibSlot | |
virtual Standard_Boolean | IsDeleted (const TopoDS_Shape &F) override |
Returns true if F a TopoDS_Shape of type edge or face has been deleted. More... | |
virtual const TopTools_ListOfShape & | Modified (const TopoDS_Shape &F) override |
Returns the list of generated Faces F. This list may be empty. More... | |
virtual const TopTools_ListOfShape & | Generated (const TopoDS_Shape &S) override |
Returns a list TopTools_ListOfShape of the faces S created in the shape. More... | |
const TopTools_ListOfShape & | FirstShape () const |
Returns the list of shapes created at the bottom of the created form. It may be an empty list. More... | |
const TopTools_ListOfShape & | LastShape () const |
Returns the list of shapes created at the top of the created form. It may be an empty list. More... | |
const TopTools_ListOfShape & | FacesForDraft () const |
Returns a list of the limiting and glueing faces generated by the feature. These faces did not originally exist in the basis shape. The list provides the information necessary for subsequent addition of a draft to a face. It may be an empty list. If a face has tangent edges, no draft is possible, and the tangent edges must subsequently be removed if you want to add a draft to the face. More... | |
const TopTools_ListOfShape & | NewEdges () const |
Returns a list of the limiting and glueing edges generated by the feature. These edges did not originally exist in the basis shape. The list provides the information necessary for subsequent addition of fillets. It may be an empty list. More... | |
const TopTools_ListOfShape & | TgtEdges () const |
Returns a list of the tangent edges among the limiting and glueing edges generated by the feature. These edges did not originally exist in the basis shape and are tangent to the face against which the feature is built. The list provides the information necessary for subsequent addition of fillets. It may be an empty list. If an edge is tangent, no fillet is possible, and the edge must subsequently be removed if you want to add a fillet. More... | |
BRepFeat_StatusError | CurrentStatusError () const |
Public Member Functions inherited from BRepBuilderAPI_MakeShape | |
virtual void | Build () |
This is called by Shape(). It does nothing but may be redefined. More... | |
virtual const TopoDS_Shape & | Shape () |
Returns a shape built by the shape construction algorithm. Raises exception StdFail_NotDone if the shape was not built. More... | |
operator TopoDS_Shape () | |
Public Member Functions inherited from BRepBuilderAPI_Command | |
virtual | ~BRepBuilderAPI_Command () |
virtual Standard_Boolean | IsDone () const |
void | Check () const |
Raises NotDone if done is false. More... | |
MakeRevolutionForm Generates a surface of revolution in the feature as it slides along a revolved face in the basis shape. The semantics of mechanical features is built around giving thickness to a contour. This thickness can either be unilateral - on one side of the contour - or bilateral - on both sides. As in the semantics of form features, the thickness is defined by construction of shapes in specific contexts. The development contexts differ, however,in case of mechanical features. Here they include extrusion:
BRepFeat_MakeRevolutionForm::BRepFeat_MakeRevolutionForm | ( | ) |
initializes the linear form class.
BRepFeat_MakeRevolutionForm::BRepFeat_MakeRevolutionForm | ( | const TopoDS_Shape & | Sbase, |
const TopoDS_Wire & | W, | ||
const Handle< Geom_Plane > & | Plane, | ||
const gp_Ax1 & | Axis, | ||
const Standard_Real | Height1, | ||
const Standard_Real | Height2, | ||
const Standard_Integer | Fuse, | ||
Standard_Boolean & | Sliding | ||
) |
a contour W, a shape Sbase and a plane P are initialized to serve as the basic elements in the construction of the rib or groove. The axis Axis of the revolved surface in the basis shape defines the feature's axis of revolution. Height1 and Height2 may be used as limits to the construction of the feature. Fuse offers a choice between:
void BRepFeat_MakeRevolutionForm::Add | ( | const TopoDS_Edge & | E, |
const TopoDS_Face & | OnFace | ||
) |
Indicates that the edge <E> will slide on the face <OnFace>. Raises ConstructionError if the face does not belong to the basis shape, or the edge to the prismed shape.
void BRepFeat_MakeRevolutionForm::Init | ( | const TopoDS_Shape & | Sbase, |
const TopoDS_Wire & | W, | ||
const Handle< Geom_Plane > & | Plane, | ||
const gp_Ax1 & | Axis, | ||
const Standard_Real | Height1, | ||
const Standard_Real | Height2, | ||
const Standard_Integer | Fuse, | ||
Standard_Boolean & | Sliding | ||
) |
Initializes this construction algorithm A contour W, a shape Sbase and a plane P are initialized to serve as the basic elements in the construction of the rib or groove. The axis Axis of the revolved surface in the basis shape defines the feature's axis of revolution. Height1 and Height2 may be used as limits to the construction of the feature. Fuse offers a choice between:
void BRepFeat_MakeRevolutionForm::Perform | ( | ) |
Performs a prism from the wire to the plane along the basis shape S. Reconstructs the feature topologically.
Standard_Boolean BRepFeat_MakeRevolutionForm::Propagate | ( | TopTools_ListOfShape & | L, |
const TopoDS_Face & | F, | ||
const gp_Pnt & | FPoint, | ||
const gp_Pnt & | LPoint, | ||
Standard_Boolean & | falseside | ||
) |